      program readedgar

      real co(360,180)
      integer index(360,180)

      double precision juldate,julyear,julper
      character*11 filename
      character*80 fieldfile,lastfile,lastfile2
      character dateend*6,timeend*6
      character dateend2*6,timeend2*6

C Set some parameters: number of particles, kind of trajectory, startdate, enddate of simulation
************************************************************************************************

      numpart=16666
      kkind=1
      
      fieldfile = '/vola/caro/AVN_analysis/AVN_Data/FIELDS_OLD'
      open(23,file=fieldfile,status='unknown')
        do i=1,25
         read(23,*)
        end do
       read(23,'(57x,i6,i2)') ilastfile2,istarttime
      close(23)

      fieldfile = '/vola/caro/AVN_analysis/AVN_Data/FIELDS'
      open(23,file=fieldfile,status='unknown')
        do i=1,25
         read(23,*)
        end do
       read(23,'(57x,i6,i2)') ilastfile,iendtime
      close(23)

      fieldfile = '/vola/caro/AVN_analysis/AVN_Data/FIELDS_OLD'
      open(23,file=fieldfile,status='unknown')
        do i=1,25
         read(23,*)
        end do
       read(23,'(55x,a)') lastfile2
      close(23)

      fieldfile = '/vola/caro/AVN_analysis/AVN_Data/FIELDS'
      open(23,file=fieldfile,status='unknown')
        do i=1,25
         read(23,*)
        end do
       read(23,'(55x,a)') lastfile
      close(23)


      ienddate = ilastfile + 20000000
      istartdate = ilastfile2 + 20000000
      istarttime = istarttime*10**3
      iendtime = iendtime*10**3

       write(*,*) istartdate
       write(*,*) istarttime
       write(*,*) ienddate
       write(*,*) iendtime

       write(dateend,'(a)') lastfile(3:8)
       write(timeend,'(a)') lastfile(9:10)//'0000'
       write(dateend2,'(a)') lastfile2(3:8)
       write(timeend2,'(a)') lastfile2(9:10)//'0000'

C Give indices to the different continents and set emissions to zero
********************************************************************

      do 10 i=1,360  
        do 10 j=1,180  
          if ((j.gt.102).and.(i.gt.10).and.(i.le.128)) then
            index(i,j)=1       ! N-America
          else if ((j.gt.126).and.(i.gt.155).and.(i.le.240)) then
            index(i,j)=2       ! Europe
            if (((i.le.207).or.(j.gt.132)).and.
     +      ((i.le.232).or.(j.gt.142))) then
              index(i,j)=2       ! Europe
            else
              index(i,j)=3       ! Asia
            endif
          else if (((j.gt.80).and.(i.gt.240).and.(i.le.350)).or. 
     +    ((j.gt.105).and.(j.le.126).and.
     +    (i.gt.214).and.(i.le.240))) then
            index(i,j)=3       ! Asia
          else
            index(i,j)=0       ! No continent
          endif
10        co(i,j)=0.

C Determine fraction of emissions released within simulation period
*******************************************************************

      julyear=juldate(20020101,0)-juldate(20010101,0)
c     julyear=dble(365.25)
      julper=juldate(ienddate,iendtime)-juldate(istartdate,istarttime)
      fract=julper/julyear

C Read EDGAR inventory
**********************

      open(10,file='CONTROL')
200   read(10,'(a)',end=199) filename       !which categories are to be used

      open(20,file=filename)
      do 11 i=1,12
11      read(20,*)

100   read(20,*,end=99) igrid,jgrid,cocell
      i=igrid+181
      j=jgrid+91
      co(i,j)=co(i,j)+cocell
      goto 100
99    continue
      close(20)

      goto 200
199   continue
      close(10)


C Convert to kg CO/year -> convert to kg CO/period
**************************************************

      do 25 i=1,360  
        do 25 j=1,180  
25        co(i,j)=co(i,j)*28./12.*fract


C Check total
*************

      cotot=0.
      do 20 i=1,360  
        do 20 j=1,180  
c N-America, Asia and Europe
c         if (index(i,j).gt.0) cotot=cotot+co(i,j)
c only N-America and Europe 
          if (index(i,j).eq.1.or.index(i,j).eq.2) then
            cotot=cotot+co(i,j)
          endif
20        continue

      write(*,*) cotot,cotot/28.*12.


C Generate RELEASES file
************************

      open(10,file='RELEASES')
     
      write(10,'(a)')'**************************************'
      write(10,*)
      write(10,*)
      write(10,*)
      write(10,*) 'Input file for  FLEXPART   ' 
      write(10,*) 'Please select your options ' 
      write(10,*)
      write(10,*)
      write(10,*)
      write(10,'(a)')'**************************************'
      write(10,'(a)')'++++++++++++++++++++++++++++++++++++++'
      write(10,*) '2        Total number of species emitted'
      write(10,*) '22       Index of species in file SPECIES'
      write(10,*) '22       Index of species in file SPECIES'
      write(10,'(a)')'======================================'
      numbtot=0
      do 40 i=1,360
        do 40 j=1,180
c N-America, Asia and Europe
c         if (index(i,j).gt.0) then
c only N-America and Europe 
          if (index(i,j).eq.1.or.index(i,j).eq.2) then
            numb=nint(co(i,j)/cotot*float(numpart))
            if ((co(i,j)/cotot).gt.0..and.numb.eq.0) then
             numb = 1
            endif
            numbtot=numbtot+numb
            xl=float(i-1)-180.
            xr=float(i)-180.
            yl=float(j-1)-90.
            yr=float(j)-90.

            if (numb.gt.0) then
              write(10,*) kkind
              write(10,*) '20'//dateend2//' '//timeend2
              write(10,*) '20'//dateend//' '//timeend
              write(10,*) xl
              write(10,*) yl
              write(10,*) xr
              write(10,*) yr
              write(10,*) 0.
              write(10,*) 400.
              write(10,*) numb
              if (index(i,j).eq.1) then
                write(10,*) co(i,j)
                write(10,*) 0.
                write(10,*) 0.
              else if (index(i,j).eq.2) then
                write(10,*) 0.
                write(10,*) co(i,j)
                write(10,*) 0.
c             else if (index(i,j).eq.3) then
c               write(10,*) 0.
c               write(10,*) 0.
c               write(10,*) co(i,j)
              endif
              write(10,'(a6,i3.3,i3.3,a1)') 'EDGAR_',i,j
              write(10,*)
            endif  !(numb.gt.0)

          endif !(index(i,j).gt.0)

40        continue

      write(*,*) numbtot

      end


      FUNCTION juldate(YYYYMMDD,HHMISS)
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                                             *
*     Calculates the Julian date                                              *
*                                                                             *
*     AUTHOR: Andreas Stohl (15 October 1993)                                 *
*                                                                             *
*     Variables:                                                              *
*     DD             Day                                                      *
*     HH             Hour                                                     *
*     HHMISS         Hour, minute + second                                    *
*     JA,JM,JY       help variables                                           *
*     JULDATE        Julian Date                                              *
*     JULDAY         help variable                                            *
*     MI             Minute                                                   *
*     MM             Month                                                    *
*     SS             Second                                                   *
*     YYYY           Year                                                     *
*     YYYYMMDDHH     Date and Time                                            *
*                                                                             *
*     Constants:                                                              *
*     IGREG          help constant                                            *
*                                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

      IMPLICIT NONE

      INTEGER YYYYMMDD,YYYY,MM,DD,HH,MI,SS,HHMISS
      INTEGER JULDAY,JY,JM,JA,IGREG
      REAL*8 juldate
      PARAMETER (IGREG=15+31*(10+12*1582))

      YYYY=YYYYMMDD/10000
      MM=(YYYYMMDD-10000*YYYY)/100
      DD=YYYYMMDD-10000*YYYY-100*MM
      HH=HHMISS/10000
      MI=(HHMISS-10000*HH)/100
      SS=HHMISS-10000*HH-100*MI

      IF (YYYY.EQ.0) PAUSE 'There is no Year Zero.'
      IF (YYYY.LT.0) YYYY=YYYY+1
      IF (MM.GT.2) THEN
        JY=YYYY
        JM=MM+1
      ELSE
        JY=YYYY-1
        JM=MM+13
      ENDIF
      JULDAY=INT(365.25*JY)+INT(30.6001*JM)+DD+1720995
      IF (DD+31*(MM+12*YYYY).GE.IGREG) THEN
        JA=INT(0.01*JY)
        JULDAY=JULDAY+2-JA+INT(0.25*JA)
      ENDIF

      juldate=DBLE(FLOAT(JULDAY))+DBLE(FLOAT(HH)/24.)+
     +DBLE(FLOAT(MI)/1440.)+DBLE(FLOAT(SS)/86400.)

      RETURN
      END

