      subroutine fixparticles(error)
********************************************************************************
*                                                                              *
*     This routine fixes the release times and release locations of all        *
*     particles. It also attributes the mass to individual particles.          *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     18 May 1996                                                              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* ideltas [s]          simulation period                                       *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      real thelp,xaux,yhelp,zhelp,ran1
      integer idummy,i,j,k,ih
      logical error
      data idummy/-7/


      error=.false.


C Specify release time (itra1), release location (xtra1,ytra1,ztra1), mass
C (xmass1), kind (kind) and release point (ident) for each particle.  

C Release times are assumed to be equally distributed between the start and
C the end time of the release.
C Release heights are determined by a random number, equally distributed
C between the lower and the upper height above ground of the release.
***************************************************************************
      
      do 10 i=1,numpoint
        thelp=float(ireleaseend(i)-ireleasestart(i))/float(npart(i))
        xaux=xpoint2(i)-xpoint1(i)
        yhelp=ypoint2(i)-ypoint1(i)
        zhelp=zpoint2(i)-zpoint1(i)
        do 10 j=1,npart(i)
          numpart=numpart+1
          if (numpart.gt.maxpart) goto 996
          nclass(numpart)=min(int(ran1(idummy)*float(nclassunc))+1,
     +    nclassunc)
          xtra1(numpart)=xpoint1(i)+ran1(idummy)*xaux
          if (xglobal) then
            if (xtra1(numpart).gt.float(nx-1)) xtra1(numpart)=
     +      xtra1(numpart)-float(nx-1)
            if (xtra1(numpart).lt.0.) xtra1(numpart)=
     +      xtra1(numpart)+float(nx-1)
          endif
          ytra1(numpart)=ypoint1(i)+ran1(idummy)*yhelp
          ztra1(numpart)=zpoint1(i)+ran1(idummy)*zhelp
          do 20 k=1,nspec
20          xmass1(numpart,k)=xmass(i,k)/float(npart(i))
          npoint(numpart)=i
          if (kkind(i).eq.1) then
            kind(numpart)=.true.
          else
            kind(numpart)=.false.
          endif
          idt(numpart)=mintime               ! first time step
          itra1(numpart)=ireleasestart(i)+int((0.5+float(j-1))*thelp)
          ih=mod(itra1(numpart),abs(lsynctime)) ! only intervals of lsynctime
          itra1(numpart)=itra1(numpart)-ih    ! seconds are allowed
          itramem(numpart)=itra1(numpart)
10        itrasplit(numpart)=itra1(numpart)+ldirect*itsplit

      return

996   error=.true.
      write(*,*) '#####################################################'
      write(*,*) '#### FLEXPART MODEL SUBROUTINE FIXPARTICLES:     ####'
      write(*,*) '####                                             ####'
      write(*,*) '#### ERROR - TOTAL NUMBER OF PARTICLES SPECIFIED ####'
      write(*,*) '#### IN FILE "RELEASES" OR CARRIED FORWARD FROM  ####'
      write(*,*) '#### PREVIOUS RUN EXCEEDS THE MAXIMUM ALLOWED    ####'
      write(*,*) '#### NUMBER. REDUCE EITHER NUMBER OF PARTICLES   ####'
      write(*,*) '#### PER RELEASE POINT OR REDUCE NUMBE OF        ####'
      write(*,*) '#### RELEASE POINTS.                             ####'
      write(*,*) '#####################################################'
      return

      end
